/* es drivers for svgalib */
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>
#include <stdio.h>
#include "es.h"

GraphicsContext *physicalscreen;

#define VGAMODE	G640x480x64K

void es_init()
{
 vga_setmode(VGAMODE);
 gl_setcontextvga(VGAMODE);
 physicalscreen=gl_allocatecontext();
 gl_getcontext(physicalscreen);

 if (mouse_init("/dev/mouse",vga_getmousetype(),1200)!=0)
 {
  fprintf(stderr,"Couldn't initialize mouse, aborting\n");
  exit(1);
 }

 ev.mx=ev.my=0; ev.ox=ev.oy=1;

 mouse_setposition(0,0);
 mouse_setxrange(0,WIDTH-2);
 mouse_setyrange(0,HEIGHT-1);

 gl_setwritemode(WRITEMODE_OVERWRITE | FONT_COMPRESSED);
 gl_setfont(8,8,gl_font8x8);
 gl_setfontcolors(0,gl_rgbcolor(200,0,0));

 vga_screenon();
}


void es_close()
{
 mouse_close();
 vga_screenoff();
}


int es_hasmode()
{
 return vga_hasmode(VGAMODE);
}


char *es_getmodename()
{
 return vga_getmodename(VGAMODE);
}


es_event es_handler(es_event t)
{
 es_event tmp;

 tmp=t;

 tmp.key=vga_getkey();
 mouse_update();
 tmp.mx=mouse_getx();
 tmp.my=mouse_gety();
 tmp.mb=mouse_getbutton();

 return tmp;
}


long es_color(int r, int g, int b)
{
 return gl_rgbcolor(r,g,b);
}


void es_setpixel(int x, int y, long c)
{
 gl_setpixel(x,y,c);
}


void es_setpixelrgb(int x, int y, int r, int g, int b)
{
 gl_setpixelrgb(x,y,r,g,b);
}


void es_setfontcolors(long bg, long fg)
{
 gl_setfontcolors(bg,fg);
}


void es_write(int x, int y, char *s)
{
 gl_write(x,y,s);
}


int es_checkbutton(int status)
{
 switch(status)
 {
  case MOUSE_LEFTBUTTON: return ES_LEFTBUTTON;
  case MOUSE_RIGHTBUTTON: return ES_RIGHTBUTTON;
  default: return ES_NOBUTTON;
 }
 
}


int es_getch()
{
 char c;

// return vga_getch();
 
 c=vga_getch();

 printf("getch=%d\n",c);

 return c;
}